// DCGSvariable.h
#ifndef _DCGSVARIABLE_H_
#define _DCGSVARIABLE_H_
#include "DCGSexpr.h"
#if 0
class Variable : public Expr
{
	Variable(char *nm, expression *v);
	Variable(char *nm, Const t, void **);

	virtual int printpar(int priority);
	virtual int printpar(FILE *f, char *fmt, int priority);
	virtual constvar &evalInt();
	int evalprintInt(FILE *f,char *fmt,constvar res);
public:
	char *getName();
	constvar getVal();
	constvar *setVal(ulong v); // { val=v;};
	bool renameInt(char *newname);
	virtual int print();
	virtual int printExpr();
	virtual constvar &eval();
	virtual constvar &typedEval(Const typeV);
	virtual int evalprint();
	virtual int evalprint(FILE *f,char *fmt);
	virtual int print(FILE *f,char *fmt="%s");
	virtual int printExpr(FILE *f,char *fmt="%s");
	int getType();
};
#endif
#if 0
class VarInt: public Variable
{
	VarInt(char *n,int *v);
	constvar &evalInt();
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	constvar &eval();
	int evalprint(FILE *f=stdout, char *fmt="%d");
};
class VarChar: public Variable
{
	VarChar(char *n, char *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	constvar &typedEval(Const typeV);
	EVALDEF;
	int evalprint(FILE *f=stdout, char *fmt="%u");
};

class VarLong: public Variable
{
	VarLong(char *n,long *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	constvar &typedEval(Const typeV);
	EVALDEF;
	int evalprint(FILE *f=stdout, char *fmt="%d");
};

class VarShort: public Variable
{
	VarShort(char *n,short *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	EVALDEF;
	int evalprint(FILE *f=stdout, char *fmt="%d");
};

class VarFloat: public Variable
{
	VarFloat(char *n,float *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	constvar &typedEval(Const typeV);
	EVALDEF;
	int evalprint(FILE *f=stdout, char *fmt="%e");
};

class VarDouble: public Variable
{
	VarDouble(char *n,double *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	constvar &typedEval(Const typeV);
	EVALDEF;
	int evalprint(FILE *f=stdout, char *fmt="%e");
};

class VarPtr: public Variable
{
	VarPtr(char *n,void *v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	int evalprint(FILE *f=stdout, char *fmt="0x%08x");
	constvar &typedEval(Const typeV);
	EVALDEF;
};

class VarString: public Variable
{
	VarString(char *n,char **v);
	int evalprintInt(FILE *f, char *fmt,constvar res);
public:
	int evalprint(FILE *f=stdout, char *fmt="%s");
	constvar &typedEval(Const typeV);
	EVALDEF;
};

class VarVar: public Variable
{
	VarVar(char *nm, expression **p);
	int evalprintInt(FILE *f, char *fmt);
public:
	constvar &typedEval(Const typeV);
	EVALDEF; 
	int evalprint(FILE *f=stdout, char *fmt="");
};
VarString *genVarString(char *n,char **v);
VarInt *genVarInt(char *n,int *v);
VarLong *genVarLong(char *n,long *v);
VarShort *genVarShort(char *n,short *v);
VarFloat *genVarFloat(char *n,float *v);
VarDouble *genVarDouble(char *n,double *v);
VarChar *genVarChar(char *n,char *v);
VarPtr *genVarPtr(char *n,void **v);
VarVar *genVarVar(char *n,expression **v);
inline Variable *GenVar(char *n, char *v) { return (Variable *) genVarChar(n,v);}
inline Variable *GenVar(char *n, char **v) { return (Variable *) genVarString(n,v);}
inline Variable *GenVar(char *n, int *v) { return (Variable *) genVarInt(n,v);}
inline Variable *GenVar(char *n, long *v) { return (Variable *) genVarLong(n,v);}
inline Variable *GenVar(char *n, short *v) { return (Variable *) genVarShort(n,v);}
inline Variable *GenVar(char *n, float *v) { return (Variable *) genVarFloat(n,v);}
inline Variable *GenVar(char *n, double *v) { return (Variable *) genVarDouble(n,v);}
inline Variable *GenVar(char *n, void **v) { return (Variable *) genVarPtr(n,v);}
inline Variable *GenVar(char *n, expression **v) { return (Variable *) genVarVar(n,v);}
#define genVariable(v) GenVar(#v, &v)
#endif
#endif